require '_h2ph_pre.ph';

unless(defined(&_MACHINE_ASM_H_)) {
    eval 'sub _MACHINE_ASM_H_ () {1;}' unless defined(&_MACHINE_ASM_H_);
    require 'sys/cdefs.ph';
    if(defined(&PIC)) {
	eval 'sub PIC_PROLOGUE () { &pushl % &ebx;  &call 1 &f; 1:  &popl % &ebx;  &addl $ &_GLOBAL_OFFSET_TABLE_+[.-1 &b],% &ebx;}' unless defined(&PIC_PROLOGUE);
	eval 'sub PIC_EPILOGUE () { &popl % &ebx;}' unless defined(&PIC_EPILOGUE);
	eval 'sub PIC_PLT {
	    local($x) = @_;
    	    eval q($x@ &PLT);
	}' unless defined(&PIC_PLT);
	eval 'sub PIC_GOT {
	    local($x) = @_;
    	    eval q($x@ &GOT(% &ebx));
	}' unless defined(&PIC_GOT);
	eval 'sub PIC_GOTOFF {
	    local($x) = @_;
    	    eval q($x@ &GOTOFF(% &ebx));
	}' unless defined(&PIC_GOTOFF);
    } else {
	eval 'sub PIC_PROLOGUE () {1;}' unless defined(&PIC_PROLOGUE);
	eval 'sub PIC_EPILOGUE () {1;}' unless defined(&PIC_EPILOGUE);
	eval 'sub PIC_PLT {
	    local($x) = @_;
    	    eval q($x);
	}' unless defined(&PIC_PLT);
	eval 'sub PIC_GOT {
	    local($x) = @_;
    	    eval q($x);
	}' unless defined(&PIC_GOT);
	eval 'sub PIC_GOTOFF {
	    local($x) = @_;
    	    eval q($x);
	}' unless defined(&PIC_GOTOFF);
    }
    if(defined(&__ELF__)) {
	eval 'sub CNAME {
	    local($csym) = @_;
    	    eval q($csym);
	}' unless defined(&CNAME);
	eval 'sub HIDENAME {
	    local($asmsym) = @_;
    	    eval q( &__CONCAT(.,$asmsym));
	}' unless defined(&HIDENAME);
    } else {
	eval 'sub CNAME {
	    local($csym) = @_;
    	    eval q( &__CONCAT( &_,$csym));
	}' unless defined(&CNAME);
	eval 'sub HIDENAME {
	    local($asmsym) = @_;
    	    eval q($asmsym);
	}' unless defined(&HIDENAME);
    }
    eval 'sub _START_ENTRY () {. &text; . &p2align 2,0x90;}' unless defined(&_START_ENTRY);
    eval 'sub _ENTRY {
        local($x) = @_;
	    eval q( &_START_ENTRY; . &globl  &CNAME($x); . &type  &CNAME($x),@ &function;  &CNAME($x):);
    }' unless defined(&_ENTRY);
    if(defined(&PROF)) {
	eval 'sub ENTRY {
	    local($x) = @_;
    	    eval q( &_ENTRY($x);  &pushl % &ebp;  &movl % &esp,% &ebp;  &call  &PIC_PLT( &HIDENAME( &mcount));  &popl % &ebp);
	}' unless defined(&ENTRY);
    } else {
	eval 'sub ENTRY {
	    local($x) = @_;
    	    eval q( &_ENTRY($x));
	}' unless defined(&ENTRY);
    }
    eval 'sub RCSID {
        local($x) = @_;
	    eval q(. &text; . &asciz $x);
    }' unless defined(&RCSID);
    if(defined(&_ARCH_INDIRECT)) {
	eval 'sub ANAME {
	    local($x) = @_;
    	    eval q( &CNAME( &__CONCAT( &__CONCAT( &__, &_ARCH_INDIRECT),$x)));
	}' unless defined(&ANAME);
	eval 'sub ASELNAME {
	    local($x) = @_;
    	    eval q( &CNAME( &__CONCAT( &__arch_select_,$x)));
	}' unless defined(&ASELNAME);
	eval 'sub AVECNAME {
	    local($x) = @_;
    	    eval q( &CNAME( &__CONCAT( &__arch_,$x)));
	}' unless defined(&AVECNAME);
	eval 'sub GNAME {
	    local($x) = @_;
    	    eval q( &CNAME( &__CONCAT( &__generic_,$x)));
	}' unless defined(&GNAME);
	if(defined(&PIC)) {
	    eval 'sub ARCH_DISPATCH {
	        local($x) = @_;
    		eval q( &_START_ENTRY; . &globl  &CNAME($x); . &type  &CNAME($x),@ &function;  &CNAME($x): ;  &PIC_PROLOGUE;  &movl  &PIC_GOT( &AVECNAME($x)),% &eax;  &PIC_EPILOGUE;  &jmpl *(% &eax));
	    }' unless defined(&ARCH_DISPATCH);
	    eval 'sub ARCH_SELECT {
	        local($x) = @_;
    		eval q( &_START_ENTRY; . &type  &ASELNAME($x),@ &function;  &ASELNAME($x):  &PIC_PROLOGUE;  &call  &PIC_PLT( &CNAME( &__get_hw_float));  &testl % &eax,% &eax;  &movl  &PIC_GOT( &ANAME($x)),% &eax;  &jne 8 &f;  &movl  &PIC_GOT( &GNAME($x)),% &eax; 8:  &movl  &PIC_GOT( &AVECNAME($x)),% &edx;  &movl % &eax,(% &edx);  &PIC_EPILOGUE;  &jmpl *% &eax);
	    }' unless defined(&ARCH_SELECT);
	} else {
	    eval 'sub ARCH_DISPATCH {
	        local($x) = @_;
    		eval q( &_START_ENTRY; . &globl  &CNAME($x); . &type  &CNAME($x),@ &function;  &CNAME($x): ;  &jmpl * &AVECNAME($x));
	    }' unless defined(&ARCH_DISPATCH);
	    eval 'sub ARCH_SELECT {
	        local($x) = @_;
    		eval q( &_START_ENTRY; . &type  &ASELNAME($x),@ &function;  &ASELNAME($x):  &call  &CNAME( &__get_hw_float);  &testl % &eax,% &eax;  &movl $ &ANAME($x),% &eax;  &jne 8 &f;  &movl $ &GNAME($x),% &eax; 8:  &movl % &eax, &AVECNAME($x);  &jmpl *% &eax);
	    }' unless defined(&ARCH_SELECT);
	}
	eval 'sub ARCH_VECTOR {
	    local($x) = @_;
    	    eval q(. &data; . &p2align 2; . &globl  &AVECNAME($x); . &type  &AVECNAME($x),@ &object; . &size  &AVECNAME($x),4;  &AVECNAME($x): . &long ASELNAME($x));
	}' unless defined(&ARCH_VECTOR);
	undef(&_ENTRY) if defined(&_ENTRY);
	eval 'sub _ENTRY {
	    local($x) = @_;
    	    eval q( &ARCH_VECTOR($x);  &ARCH_SELECT($x);  &ARCH_DISPATCH($x);  &_START_ENTRY; . &globl  &ANAME($x); . &type  &ANAME($x),@ &function;  &ANAME($x):);
	}' unless defined(&_ENTRY);
    }
}
1;
