require '_h2ph_pre.ph';

unless(defined(&_NFS_NFS_H_)) {
    eval 'sub _NFS_NFS_H_ () {1;}' unless defined(&_NFS_NFS_H_);
    if(defined(&KERNEL)) {
	require 'opt_nfs.ph';
    }
    eval 'sub NFS_MAXIOVEC () {34;}' unless defined(&NFS_MAXIOVEC);
    eval 'sub NFS_TICKINTVL () {5;}' unless defined(&NFS_TICKINTVL);
    eval 'sub NFS_HZ () {( &hz /  &nfs_ticks);}' unless defined(&NFS_HZ);
    eval 'sub NFS_TIMEO () {(1*  &NFS_HZ);}' unless defined(&NFS_TIMEO);
    eval 'sub NFS_MINTIMEO () {(1*  &NFS_HZ);}' unless defined(&NFS_MINTIMEO);
    eval 'sub NFS_MAXTIMEO () {(60*  &NFS_HZ);}' unless defined(&NFS_MAXTIMEO);
    eval 'sub NFS_MINIDEMTIMEO () {(5*  &NFS_HZ);}' unless defined(&NFS_MINIDEMTIMEO);
    eval 'sub NFS_MAXREXMIT () {100;}' unless defined(&NFS_MAXREXMIT);
    eval 'sub NFS_MAXWINDOW () {1024;}' unless defined(&NFS_MAXWINDOW);
    eval 'sub NFS_RETRANS () {10;}' unless defined(&NFS_RETRANS);
    eval 'sub NFS_MAXGRPS () {16;}' unless defined(&NFS_MAXGRPS);
    unless(defined(&NFS_MINATTRTIMO)) {
	eval 'sub NFS_MINATTRTIMO () {3;}' unless defined(&NFS_MINATTRTIMO);
    }
    unless(defined(&NFS_MAXATTRTIMO)) {
	eval 'sub NFS_MAXATTRTIMO () {60;}' unless defined(&NFS_MAXATTRTIMO);
    }
    unless(defined(&NFS_MINDIRATTRTIMO)) {
	eval 'sub NFS_MINDIRATTRTIMO () {30;}' unless defined(&NFS_MINDIRATTRTIMO);
    }
    unless(defined(&NFS_MAXDIRATTRTIMO)) {
	eval 'sub NFS_MAXDIRATTRTIMO () {60;}' unless defined(&NFS_MAXDIRATTRTIMO);
    }
    eval 'sub NFS_WSIZE () {8192;}' unless defined(&NFS_WSIZE);
    eval 'sub NFS_RSIZE () {8192;}' unless defined(&NFS_RSIZE);
    eval 'sub NFS_READDIRSIZE () {8192;}' unless defined(&NFS_READDIRSIZE);
    eval 'sub NFS_DEFRAHEAD () {1;}' unless defined(&NFS_DEFRAHEAD);
    eval 'sub NFS_MAXRAHEAD () {4;}' unless defined(&NFS_MAXRAHEAD);
    eval 'sub NFS_MAXUIDHASH () {64;}' unless defined(&NFS_MAXUIDHASH);
    eval 'sub NFS_MAXASYNCDAEMON () {20;}' unless defined(&NFS_MAXASYNCDAEMON);
    eval 'sub NFS_MAXGATHERDELAY () {100;}' unless defined(&NFS_MAXGATHERDELAY);
    unless(defined(&NFS_GATHERDELAY)) {
	eval 'sub NFS_GATHERDELAY () {10;}' unless defined(&NFS_GATHERDELAY);
    }
    eval 'sub NFS_DIRBLKSIZ () {4096;}' unless defined(&NFS_DIRBLKSIZ);
    if(defined(&KERNEL)) {
	eval 'sub DIRBLKSIZ () {512;}' unless defined(&DIRBLKSIZ);
    }
    eval 'sub NMOD {
        local($a) = @_;
	    eval q((($a) %  &nfs_asyncdaemons));
    }' unless defined(&NMOD);
    eval 'sub NFS_CMPFH {
        local($n, $f, $s) = @_;
	    eval q((-> &n_fhsize ==  && ! &bcmp(-> &n_fhp, ($f), ($s))));
    }' unless defined(&NFS_CMPFH);
    eval 'sub NFS_ISV3 {
        local($v) = @_;
	    eval q(( &VFSTONFS(($v)-> &v_mount)-> &nm_flag &  &NFSMNT_NFSV3));
    }' unless defined(&NFS_ISV3);
    eval 'sub NFS_SRVMAXDATA {
        local($n) = @_;
	    eval q(((($n)-> &nd_flag &  &ND_NFSV3) ? ((($n)-> &nd_nam2) ?  &NFS_MAXDGRAMDATA :  &NFS_MAXDATA) :  &NFS_V2MAXDATA));
    }' unless defined(&NFS_SRVMAXDATA);
    eval 'sub B_INVAFTERWRITE () { &B_NOCACHE;}' unless defined(&B_INVAFTERWRITE);
    unless(defined(&IO_METASYNC)) {
	eval 'sub IO_METASYNC () {0;}' unless defined(&IO_METASYNC);
    }
    eval 'sub NFS_SVCALLOC () {256;}' unless defined(&NFS_SVCALLOC);
    eval 'sub NFS_UIDALLOC () {128;}' unless defined(&NFS_UIDALLOC);
    eval 'sub NFS_ARGSVERSION () {3;}' unless defined(&NFS_ARGSVERSION);
    eval 'sub NFSMNT_SOFT () {0x00000001;}' unless defined(&NFSMNT_SOFT);
    eval 'sub NFSMNT_WSIZE () {0x00000002;}' unless defined(&NFSMNT_WSIZE);
    eval 'sub NFSMNT_RSIZE () {0x00000004;}' unless defined(&NFSMNT_RSIZE);
    eval 'sub NFSMNT_TIMEO () {0x00000008;}' unless defined(&NFSMNT_TIMEO);
    eval 'sub NFSMNT_RETRANS () {0x00000010;}' unless defined(&NFSMNT_RETRANS);
    eval 'sub NFSMNT_MAXGRPS () {0x00000020;}' unless defined(&NFSMNT_MAXGRPS);
    eval 'sub NFSMNT_INT () {0x00000040;}' unless defined(&NFSMNT_INT);
    eval 'sub NFSMNT_NOCONN () {0x00000080;}' unless defined(&NFSMNT_NOCONN);
    eval 'sub NFSMNT_NQNFS () {0x00000100;}' unless defined(&NFSMNT_NQNFS);
    eval 'sub NFSMNT_NFSV3 () {0x00000200;}' unless defined(&NFSMNT_NFSV3);
    eval 'sub NFSMNT_KERB () {0x00000400;}' unless defined(&NFSMNT_KERB);
    eval 'sub NFSMNT_DUMBTIMR () {0x00000800;}' unless defined(&NFSMNT_DUMBTIMR);
    eval 'sub NFSMNT_LEASETERM () {0x00001000;}' unless defined(&NFSMNT_LEASETERM);
    eval 'sub NFSMNT_READAHEAD () {0x00002000;}' unless defined(&NFSMNT_READAHEAD);
    eval 'sub NFSMNT_DEADTHRESH () {0x00004000;}' unless defined(&NFSMNT_DEADTHRESH);
    eval 'sub NFSMNT_RESVPORT () {0x00008000;}' unless defined(&NFSMNT_RESVPORT);
    eval 'sub NFSMNT_RDIRPLUS () {0x00010000;}' unless defined(&NFSMNT_RDIRPLUS);
    eval 'sub NFSMNT_READDIRSIZE () {0x00020000;}' unless defined(&NFSMNT_READDIRSIZE);
    eval 'sub NFSMNT_ACREGMIN () {0x00040000;}' unless defined(&NFSMNT_ACREGMIN);
    eval 'sub NFSMNT_ACREGMAX () {0x00080000;}' unless defined(&NFSMNT_ACREGMAX);
    eval 'sub NFSMNT_ACDIRMIN () {0x00100000;}' unless defined(&NFSMNT_ACDIRMIN);
    eval 'sub NFSMNT_ACDIRMAX () {0x00200000;}' unless defined(&NFSMNT_ACDIRMAX);
    eval 'sub NFSSTA_HASWRITEVERF () {0x00040000;}' unless defined(&NFSSTA_HASWRITEVERF);
    eval 'sub NFSSTA_GOTPATHCONF () {0x00080000;}' unless defined(&NFSSTA_GOTPATHCONF);
    eval 'sub NFSSTA_GOTFSINFO () {0x00100000;}' unless defined(&NFSSTA_GOTFSINFO);
    eval 'sub NFSSTA_MNTD () {0x00200000;}' unless defined(&NFSSTA_MNTD);
    eval 'sub NFSSTA_DISMINPROG () {0x00400000;}' unless defined(&NFSSTA_DISMINPROG);
    eval 'sub NFSSTA_DISMNT () {0x00800000;}' unless defined(&NFSSTA_DISMNT);
    eval 'sub NFSSTA_SNDLOCK () {0x01000000;}' unless defined(&NFSSTA_SNDLOCK);
    eval 'sub NFSSTA_WANTSND () {0x02000000;}' unless defined(&NFSSTA_WANTSND);
    eval 'sub NFSSTA_RCVLOCK () {0x04000000;}' unless defined(&NFSSTA_RCVLOCK);
    eval 'sub NFSSTA_WANTRCV () {0x08000000;}' unless defined(&NFSSTA_WANTRCV);
    eval 'sub NFSSTA_WAITAUTH () {0x10000000;}' unless defined(&NFSSTA_WAITAUTH);
    eval 'sub NFSSTA_HASAUTH () {0x20000000;}' unless defined(&NFSSTA_HASAUTH);
    eval 'sub NFSSTA_WANTAUTH () {0x40000000;}' unless defined(&NFSSTA_WANTAUTH);
    eval 'sub NFSSTA_AUTHERR () {0x80000000;}' unless defined(&NFSSTA_AUTHERR);
    if(defined(&NFS_NPROCS)) {
    }
    eval 'sub NFSSVC_BIOD () {0x002;}' unless defined(&NFSSVC_BIOD);
    eval 'sub NFSSVC_NFSD () {0x004;}' unless defined(&NFSSVC_NFSD);
    eval 'sub NFSSVC_ADDSOCK () {0x008;}' unless defined(&NFSSVC_ADDSOCK);
    eval 'sub NFSSVC_AUTHIN () {0x010;}' unless defined(&NFSSVC_AUTHIN);
    eval 'sub NFSSVC_GOTAUTH () {0x040;}' unless defined(&NFSSVC_GOTAUTH);
    eval 'sub NFSSVC_AUTHINFAIL () {0x080;}' unless defined(&NFSSVC_AUTHINFAIL);
    eval 'sub NFSSVC_MNTD () {0x100;}' unless defined(&NFSSVC_MNTD);
    eval 'sub NFS_NFSSTATS () {1;}' unless defined(&NFS_NFSSTATS);
    eval 'sub NFS_NFSPRIVPORT () {2;}' unless defined(&NFS_NFSPRIVPORT);
    eval 'sub FS_NFS_NAMES () {{ { 0, 0}, { "nfsstats",  &CTLTYPE_STRUCT }, { "nfsprivport",  &CTLTYPE_INT }, };}' unless defined(&FS_NFS_NAMES);
    if(defined(&KERNEL)) {
	if(defined(&MALLOC_DECLARE)) {
	}
	if(defined(&ZONE_INTERRUPT)) {
	}
	eval 'sub NFSINT_SIGMASK () {( &sigmask( &SIGINT)| &sigmask( &SIGTERM)| &sigmask( &SIGKILL)|  &sigmask( &SIGHUP)| &sigmask( &SIGQUIT));}' unless defined(&NFSINT_SIGMASK);
	eval 'sub NFSIGNORE_SOERROR {
	    local($s, $e) = @_;
    	    eval q((($e) !=  &EINTR  && ($e) !=  &ERESTART  && ($e) !=  &EWOULDBLOCK  && (($s) &  &PR_CONNREQUIRED) == 0));
	}' unless defined(&NFSIGNORE_SOERROR);
	eval 'sub R_TIMING () {0x01;}' unless defined(&R_TIMING);
	eval 'sub R_SENT () {0x02;}' unless defined(&R_SENT);
	eval 'sub R_SOFTTERM () {0x04;}' unless defined(&R_SOFTTERM);
	eval 'sub R_INTR () {0x08;}' unless defined(&R_INTR);
	eval 'sub R_SOCKERR () {0x10;}' unless defined(&R_SOCKERR);
	eval 'sub R_TPRINTFMSG () {0x20;}' unless defined(&R_TPRINTFMSG);
	eval 'sub R_MUSTRESEND () {0x40;}' unless defined(&R_MUSTRESEND);
	eval 'sub R_GETONEREP () {0x80;}' unless defined(&R_GETONEREP);
	unless(defined(&NFS_UIDHASHSIZ)) {
	    eval 'sub NFS_UIDHASHSIZ () {29;}' unless defined(&NFS_UIDHASHSIZ);
	}
	eval 'sub NUIDHASH {
	    local($sock, $uid) = @_;
    	    eval q((($sock)-> $ns_uidhashtbl[($uid) %  &NFS_UIDHASHSIZ]));
	}' unless defined(&NUIDHASH);
	unless(defined(&NFS_WDELAYHASHSIZ)) {
	    eval 'sub NFS_WDELAYHASHSIZ () {16;}' unless defined(&NFS_WDELAYHASHSIZ);
	}
	eval 'sub NWDELAYHASH {
	    local($sock, $f) = @_;
    	    eval q((&-> $ns_wdelayhashtbl[(*(($f))) %  &NFS_WDELAYHASHSIZ]));
	}' unless defined(&NWDELAYHASH);
	unless(defined(&NFS_MUIDHASHSIZ)) {
	    eval 'sub NFS_MUIDHASHSIZ () {63;}' unless defined(&NFS_MUIDHASHSIZ);
	}
	eval 'sub NMUIDHASH {
	    local($nmp, $uid) = @_;
    	    eval q((($nmp)-> $nm_uidhashtbl[($uid) %  &NFS_MUIDHASHSIZ]));
	}' unless defined(&NMUIDHASH);
	eval 'sub NFSNOHASH {
	    local($fhsum) = @_;
    	    eval q(( $nfsnodehashtbl[($fhsum) &  &nfsnodehash]));
	}' unless defined(&NFSNOHASH);
	eval 'sub nu_inetaddr () { ($nu_haddr->{had_inetaddr});}' unless defined(&nu_inetaddr);
	eval 'sub nu_nam () { ($nu_haddr->{had_nam});}' unless defined(&nu_nam);
	eval 'sub NU_INETADDR () {0x1;}' unless defined(&NU_INETADDR);
	eval 'sub NU_NAM () {0x2;}' unless defined(&NU_NAM);
	eval 'sub NU_NETFAM {
	    local($u) = @_;
    	    eval q(((($u)-> &nu_flag &  &NU_INETADDR) ?  &AF_INET :  &AF_ISO));
	}' unless defined(&NU_NETFAM);
	eval 'sub SLP_VALID () {0x01;}' unless defined(&SLP_VALID);
	eval 'sub SLP_DOREC () {0x02;}' unless defined(&SLP_DOREC);
	eval 'sub SLP_NEEDQ () {0x04;}' unless defined(&SLP_NEEDQ);
	eval 'sub SLP_DISCONN () {0x08;}' unless defined(&SLP_DISCONN);
	eval 'sub SLP_GETSTREAM () {0x10;}' unless defined(&SLP_GETSTREAM);
	eval 'sub SLP_LASTFRAG () {0x20;}' unless defined(&SLP_LASTFRAG);
	eval 'sub SLP_ALLFLAGS () {0xff;}' unless defined(&SLP_ALLFLAGS);
	eval 'sub SLP_INIT () {0x01;}' unless defined(&SLP_INIT);
	eval 'sub SLP_WANTINIT () {0x02;}' unless defined(&SLP_WANTINIT);
	eval 'sub NFSD_WAITING () {0x01;}' unless defined(&NFSD_WAITING);
	eval 'sub NFSD_REQINPROG () {0x02;}' unless defined(&NFSD_REQINPROG);
	eval 'sub NFSD_NEEDAUTH () {0x04;}' unless defined(&NFSD_NEEDAUTH);
	eval 'sub NFSD_AUTHFAIL () {0x08;}' unless defined(&NFSD_AUTHFAIL);
	eval 'sub ND_READ () { &LEASE_READ;}' unless defined(&ND_READ);
	eval 'sub ND_WRITE () { &LEASE_WRITE;}' unless defined(&ND_WRITE);
	eval 'sub ND_CHECK () {0x04;}' unless defined(&ND_CHECK);
	eval 'sub ND_LEASE () {( &ND_READ |  &ND_WRITE |  &ND_CHECK);}' unless defined(&ND_LEASE);
	eval 'sub ND_NFSV3 () {0x08;}' unless defined(&ND_NFSV3);
	eval 'sub ND_NQNFS () {0x10;}' unless defined(&ND_NQNFS);
	eval 'sub ND_KERBNICK () {0x20;}' unless defined(&ND_KERBNICK);
	eval 'sub ND_KERBFULL () {0x40;}' unless defined(&ND_KERBFULL);
	eval 'sub ND_KERBAUTH () {( &ND_KERBNICK |  &ND_KERBFULL);}' unless defined(&ND_KERBAUTH);
	eval 'sub NFSD_CHECKSLP () {0x01;}' unless defined(&NFSD_CHECKSLP);
	eval 'sub NFSW_CONTIG {
	    local($o, $n) = @_;
    	    eval q((($o)-> &nd_eoff >= ($n)-> &nd_off  && ! &bcmp(($o)-> &nd_fh, ($n)-> &nd_fh,  &NFSX_V3FH)));
	}' unless defined(&NFSW_CONTIG);
	eval 'sub NFSW_SAMECRED {
	    local($o, $n) = @_;
    	    eval q(((($o)-> &nd_flag &  &ND_KERBAUTH) == (($n)-> &nd_flag &  &ND_KERBAUTH)  && ! &bcmp(($o)-> &nd_cr, ($n)-> &nd_cr, $sizeof{\'struct ucred\'})));
	}' unless defined(&NFSW_SAMECRED);
	eval 'sub WEBNFS_ESC_CHAR () {ord(\'%\');}' unless defined(&WEBNFS_ESC_CHAR);
	eval 'sub WEBNFS_SPECCHAR_START () {0x80;}' unless defined(&WEBNFS_SPECCHAR_START);
	eval 'sub WEBNFS_NATIVE_CHAR () {0x80;}' unless defined(&WEBNFS_NATIVE_CHAR);
	eval 'sub HEXTOC {
	    local($c) = @_;
    	    eval q((($c) >= ord(\'a\' ? ((c) - (\'a\' - 10)) : 	    ((c) >= \'A\' ? ((c) - (\'A\' - 10)) : ((c) - \'0\')))));
	}' unless defined(&HEXTOC);
	eval 'sub HEXSTRTOI {
	    local($p) = @_;
    	    eval q((( &HEXTOC($p->[0]) << 4) +  &HEXTOC($p->[1])));
	}' unless defined(&HEXSTRTOI);
	if(defined(&NFS_DEBUG)) {
	    eval 'sub NFS_DEBUG_ASYNCIO () {1;}' unless defined(&NFS_DEBUG_ASYNCIO);
	    eval 'sub NFS_DEBUG_WG () {2;}' unless defined(&NFS_DEBUG_WG);
	    eval 'sub NFS_DEBUG_RC () {4;}' unless defined(&NFS_DEBUG_RC);
	    eval 'sub NFS_DPF {
	        local($cat, $args) = @_;
    		eval q( &do {  &if ( &nfs_debug &  &NFS_DEBUG_$cat)  &printf $args; }  &while (0));
	    }' unless defined(&NFS_DPF);
	} else {
	    eval 'sub NFS_DPF {
	        local($cat, $args) = @_;
    		eval q();
	    }' unless defined(&NFS_DPF);
	}
    }
}
1;
