require '_h2ph_pre.ph';

require 'sys/types.ph';
require 'sys/cdefs.ph';
require 'sys/stat.ph';
unless(defined(&CHK)) {
    sub CHK () {	( &fmt,  &args...)  &printf("%s(%d): "  &fmt "\n",  &__FUNCTION__,  &__LINE__ ,  &args);}
}
unless(defined(&PCHK)) {
    sub PCHK () {	( &fmt,  &args...) { &printf("%s(%d): "  &fmt "\n",  &__FUNCTION__,  &__LINE__ ,  &args);  &getchar();};}
}
unless(defined(&NULL)) {
    eval 'sub NULL () {0;}' unless defined(&NULL);
}
unless(defined(&KERNEL)) {
    sub KERNEL () {	1;}
}
require 'sys/errno.ph';
undef(&KERNEL) if defined(&KERNEL);
unless(defined(&EADAPT)) {
    sub EADAPT () {	( &ELAST+1);}
}
unless(defined(&ECTLR)) {
    sub ECTLR () {	( &ELAST+2);}
}
unless(defined(&EUNIT)) {
    sub EUNIT () {	( &ELAST+3);}
}
unless(defined(&ESLICE)) {
    sub ESLICE () {	( &ELAST+4);}
}
unless(defined(&EPART)) {
    sub EPART () {	( &ELAST+5);}
}
unless(defined(&ERDLAB)) {
    sub ERDLAB () {	( &ELAST+6);}
}
unless(defined(&EUNLAB)) {
    sub EUNLAB () {	( &ELAST+7);}
}
unless(defined(&EOFFSET)) {
    sub EOFFSET () {	( &ELAST+8);}
}
unless(defined(&ESALAST)) {
    sub ESALAST () {	( &ELAST+8);}
}
unless(defined(&SEEK_SET)) {
    sub SEEK_SET () {	0;}
}
unless(defined(&SEEK_CUR)) {
    sub SEEK_CUR () {	1;}
}
unless(defined(&SEEK_END)) {
    sub SEEK_END () {	2;}
}
unless(defined(&SOPEN_MAX)) {
    sub SOPEN_MAX () {	8;}
}
unless(defined(&F_READ)) {
    sub F_READ () {	0x0001;}
}
unless(defined(&F_WRITE)) {
    sub F_WRITE () {	0x0002;}
}
unless(defined(&F_RAW)) {
    sub F_RAW () {	0x0004;}
}
unless(defined(&F_NODEV)) {
    sub F_NODEV () {	0x0008;}
}
unless(defined(&isupper)) {
    sub isupper {
	local($c) = @_;
	eval q((($c) >= ord('A' && (c) <= 'Z')));
    }
}
unless(defined(&islower)) {
    sub islower {
	local($c) = @_;
	eval q((($c) >= ord('a' && (c) <= 'z')));
    }
}
unless(defined(&isspace)) {
    sub isspace {
	local($c) = @_;
	eval q((($c) == ord(' ') || (($c) >= 0x9  && ($c) <= 0xd)));
    }
}
unless(defined(&isdigit)) {
    sub isdigit {
	local($c) = @_;
	eval q((($c) >= ord('0' && (c) <= '9')));
    }
}
unless(defined(&isxdigit)) {
    sub isxdigit {
	local($c) = @_;
	eval q(( &isdigit($c) || (($c) >= ord('a' && (c) <= 'f') || ((c) >= 'A' && (c) <= 'F'))));
    }
}
unless(defined(&isascii)) {
    sub isascii {
	local($c) = @_;
	eval q((($c) >= 0|| ($c <= 0x7f)));
    }
}
unless(defined(&isalpha)) {
    sub isalpha {
	local($c) = @_;
	eval q(( &isupper($c) || ( &islower($c))));
    }
}
unless(defined(&toupper)) {
    sub toupper {
	local($c) = @_;
	eval q((($c) - ord('a' + 'A')));
    }
}
unless(defined(&tolower)) {
    sub tolower {
	local($c) = @_;
	eval q((($c) - ord('A' + 'a')));
    }
}
if(defined(&__alpha__)) {
}
unless(defined(&gets)) {
    sub gets {
	local($x) = @_;
	eval q( &ngets(($x), 0));
    }
}
unless(defined(&O_RDONLY)) {
    sub O_RDONLY () {	0x0;}
}
unless(defined(&O_WRONLY)) {
    sub O_WRONLY () {	0x1;}
}
unless(defined(&O_RDWR)) {
    sub O_RDWR () {	0x2;}
}
unless(defined(&setjmp)) {
    sub setjmp () {	 &_setjmp;}
}
unless(defined(&longjmp)) {
    sub longjmp () {	'_longjmp';}
}
unless(defined(&EV_DYNAMIC)) {
    sub EV_DYNAMIC () {	(1<<0);}
}
unless(defined(&EV_VOLATILE)) {
    sub EV_VOLATILE () {	(1<<1);}
}
unless(defined(&EV_NOHOOK)) {
    sub EV_NOHOOK () {	(1<<2);}
}
unless(defined(&bcd2bin)) {
    sub bcd2bin {
	local($bcd) = @_;
	eval q(( $bcd2bin_data[$bcd]));
    }
}
unless(defined(&bin2bcd)) {
    sub bin2bcd {
	local($bin) = @_;
	eval q(( $bin2bcd_data[$bin]));
    }
}
unless(defined(&hex2ascii)) {
    sub hex2ascii {
	local($hex) = @_;
	eval q(( $hex2ascii_data[$hex]));
    }
}
if(defined(&__i386__)) {
}
if(0) {
    eval 'sub malloc {
        local($x) = @_;
	    eval q( &malloc_debug($x,  &__FILE__,  &__LINE__));
    }' unless defined(&malloc);
    eval 'sub free {
        local($x) = @_;
	    eval q( &free_debug($x,  &__FILE__,  &__LINE__));
    }' unless defined(&free);
}
1;
