require '_h2ph_pre.ph';

unless(defined(&_SYS_SIGNAL_H_)) {
    eval 'sub _SYS_SIGNAL_H_ () {1;}' unless defined(&_SYS_SIGNAL_H_);
    require 'sys/cdefs.ph';
    require 'sys/_posix.ph';
    require 'machine/signal.ph';
    if(!defined( &_ANSI_SOURCE)  && !defined( &_POSIX_SOURCE)) {
	eval 'sub NSIG () {32;}' unless defined(&NSIG);
    }
    eval 'sub SIGHUP () {1;}' unless defined(&SIGHUP);
    eval 'sub SIGINT () {2;}' unless defined(&SIGINT);
    eval 'sub SIGQUIT () {3;}' unless defined(&SIGQUIT);
    eval 'sub SIGILL () {4;}' unless defined(&SIGILL);
    unless(defined(&_POSIX_SOURCE)) {
	eval 'sub SIGTRAP () {5;}' unless defined(&SIGTRAP);
    }
    eval 'sub SIGABRT () {6;}' unless defined(&SIGABRT);
    unless(defined(&_POSIX_SOURCE)) {
	eval 'sub SIGIOT () { &SIGABRT;}' unless defined(&SIGIOT);
	eval 'sub SIGEMT () {7;}' unless defined(&SIGEMT);
    }
    eval 'sub SIGFPE () {8;}' unless defined(&SIGFPE);
    eval 'sub SIGKILL () {9;}' unless defined(&SIGKILL);
    unless(defined(&_POSIX_SOURCE)) {
	eval 'sub SIGBUS () {10;}' unless defined(&SIGBUS);
    }
    eval 'sub SIGSEGV () {11;}' unless defined(&SIGSEGV);
    unless(defined(&_POSIX_SOURCE)) {
	eval 'sub SIGSYS () {12;}' unless defined(&SIGSYS);
    }
    eval 'sub SIGPIPE () {13;}' unless defined(&SIGPIPE);
    eval 'sub SIGALRM () {14;}' unless defined(&SIGALRM);
    eval 'sub SIGTERM () {15;}' unless defined(&SIGTERM);
    unless(defined(&_POSIX_SOURCE)) {
	eval 'sub SIGURG () {16;}' unless defined(&SIGURG);
    }
    eval 'sub SIGSTOP () {17;}' unless defined(&SIGSTOP);
    eval 'sub SIGTSTP () {18;}' unless defined(&SIGTSTP);
    eval 'sub SIGCONT () {19;}' unless defined(&SIGCONT);
    eval 'sub SIGCHLD () {20;}' unless defined(&SIGCHLD);
    eval 'sub SIGTTIN () {21;}' unless defined(&SIGTTIN);
    eval 'sub SIGTTOU () {22;}' unless defined(&SIGTTOU);
    unless(defined(&_POSIX_SOURCE)) {
	eval 'sub SIGIO () {23;}' unless defined(&SIGIO);
	eval 'sub SIGXCPU () {24;}' unless defined(&SIGXCPU);
	eval 'sub SIGXFSZ () {25;}' unless defined(&SIGXFSZ);
	eval 'sub SIGVTALRM () {26;}' unless defined(&SIGVTALRM);
	eval 'sub SIGPROF () {27;}' unless defined(&SIGPROF);
	eval 'sub SIGWINCH () {28;}' unless defined(&SIGWINCH);
	eval 'sub SIGINFO () {29;}' unless defined(&SIGINFO);
    }
    eval 'sub SIGUSR1 () {30;}' unless defined(&SIGUSR1);
    eval 'sub SIGUSR2 () {31;}' unless defined(&SIGUSR2);
    eval 'sub SIG_DFL () {(0);}' unless defined(&SIG_DFL);
    eval 'sub SIG_IGN () {(1);}' unless defined(&SIG_IGN);
    eval 'sub SIG_ERR () {(( &__sighandler_t *)-1);}' unless defined(&SIG_ERR);
    unless(defined(&_ANSI_SOURCE)) {
	unless(defined(&_POSIX_SOURCE)) {
	    eval 'sub SA_ONSTACK () {0x0001;}' unless defined(&SA_ONSTACK);
	    eval 'sub SA_RESTART () {0x0002;}' unless defined(&SA_RESTART);
	    eval 'sub SA_RESETHAND () {0x0004;}' unless defined(&SA_RESETHAND);
	    eval 'sub SA_NODEFER () {0x0010;}' unless defined(&SA_NODEFER);
	    eval 'sub SA_NOCLDWAIT () {0x0020;}' unless defined(&SA_NOCLDWAIT);
	    if(defined(&COMPAT_SUNOS)) {
		eval 'sub SA_USERTRAMP () {0x0100;}' unless defined(&SA_USERTRAMP);
	    }
	}
	eval 'sub SA_NOCLDSTOP () {0x0008;}' unless defined(&SA_NOCLDSTOP);
	eval 'sub SIG_BLOCK () {1;}' unless defined(&SIG_BLOCK);
	eval 'sub SIG_UNBLOCK () {2;}' unless defined(&SIG_UNBLOCK);
	eval 'sub SIG_SETMASK () {3;}' unless defined(&SIG_SETMASK);
	unless(defined(&_POSIX_SOURCE)) {
	    if(defined(&_BSD_SIZE_T_)) {
		undef(&_BSD_SIZE_T_) if defined(&_BSD_SIZE_T_);
	    }
	    eval 'sub SS_ONSTACK () {0x0001;}' unless defined(&SS_ONSTACK);
	    eval 'sub SS_DISABLE () {0x0004;}' unless defined(&SS_DISABLE);
	    eval 'sub MINSIGSTKSZ () {8192;}' unless defined(&MINSIGSTKSZ);
	    eval 'sub SIGSTKSZ () {( &MINSIGSTKSZ + 32768);}' unless defined(&SIGSTKSZ);
	    eval 'sub SV_ONSTACK () { &SA_ONSTACK;}' unless defined(&SV_ONSTACK);
	    eval 'sub SV_INTERRUPT () { &SA_RESTART;}' unless defined(&SV_INTERRUPT);
	    eval 'sub SV_RESETHAND () { &SA_RESETHAND;}' unless defined(&SV_RESETHAND);
	    eval 'sub SV_NODEFER () { &SA_NODEFER;}' unless defined(&SV_NODEFER);
	    eval 'sub SV_NOCLDSTOP () { &SA_NOCLDSTOP;}' unless defined(&SV_NOCLDSTOP);
	    eval 'sub sv_onstack () { &sv_flags;}' unless defined(&sv_onstack);
	    eval 'sub sigmask {
	        local($m) = @_;
    		eval q((1<< (($m)-1)));
	    }' unless defined(&sigmask);
	    eval 'sub BADSIG () { &SIG_ERR;}' unless defined(&BADSIG);
	}
    }
    if(defined(&_P1003_1B_VISIBLE_HISTORICALLY)) {
	eval 'sub SIGEV_NONE () {0;}' unless defined(&SIGEV_NONE);
	eval 'sub SIGEV_SIGNAL () {1;}' unless defined(&SIGEV_SIGNAL);
    }
}
1;
