require '_h2ph_pre.ph';

unless(defined(&_VM_MAP_)) {
    eval 'sub _VM_MAP_ () {1;}' unless defined(&_VM_MAP_);
    eval 'sub MAP_ENTRY_IS_A_MAP () {0x1;}' unless defined(&MAP_ENTRY_IS_A_MAP);
    eval 'sub MAP_ENTRY_IS_SUB_MAP () {0x2;}' unless defined(&MAP_ENTRY_IS_SUB_MAP);
    eval 'sub MAP_ENTRY_COW () {0x4;}' unless defined(&MAP_ENTRY_COW);
    eval 'sub MAP_ENTRY_NEEDS_COPY () {0x8;}' unless defined(&MAP_ENTRY_NEEDS_COPY);
    eval 'sub MAP_ENTRY_NOFAULT () {0x10;}' unless defined(&MAP_ENTRY_NOFAULT);
    eval 'sub MAP_ENTRY_USER_WIRED () {0x20;}' unless defined(&MAP_ENTRY_USER_WIRED);
    eval 'sub min_offset () { ($header->{start});}' unless defined(&min_offset);
    eval 'sub max_offset () { ($header->{end});}' unless defined(&max_offset);
    eval 'sub vm_startcopy () { &vm_rssize;}' unless defined(&vm_startcopy);
    eval 'sub vm_map_lock_drain_interlock {
        local($map) = @_;
	    eval q({  &lockmgr(($map)-> &lock,  &LK_DRAIN| &LK_INTERLOCK, ($map)-> &ref_lock,  &curproc); ($map)-> &timestamp++; });
    }' unless defined(&vm_map_lock_drain_interlock);
    if(defined(&DIAGNOSTIC)) {
	if(defined(&MAP_LOCK_DIAGNOSTIC)) {
	    eval 'sub vm_map_lock {
	        local($map) = @_;
    		eval q({  &printf (\\"locking map LK_EXCLUSIVE: 0x%x\\\\n\\", $map);  &if ( &lockmgr(&-> &lock,  &LK_EXCLUSIVE, 0,  &curproc) != 0) {  &panic(\\"vm_map_lock: failed to get lock\\"); } ($map)-> &timestamp++; });
	    }' unless defined(&vm_map_lock);
	} else {
	    eval 'sub vm_map_lock {
	        local($map) = @_;
    		eval q({  &if ( &lockmgr(&-> &lock,  &LK_EXCLUSIVE, 0,  &curproc) != 0) {  &panic(\\"vm_map_lock: failed to get lock\\"); } ($map)-> &timestamp++; });
	    }' unless defined(&vm_map_lock);
	}
    } else {
	eval 'sub vm_map_lock {
	    local($map) = @_;
    	    eval q({  &lockmgr(&-> &lock,  &LK_EXCLUSIVE, 0,  &curproc); ($map)-> &timestamp++; });
	}' unless defined(&vm_map_lock);
    }
    if(defined( &MAP_LOCK_DIAGNOSTIC)) {
	eval 'sub vm_map_unlock {
	    local($map) = @_;
    	    eval q( &do {  &printf (\\"locking map LK_RELEASE: 0x%x\\\\n\\", $map);  &lockmgr(&-> &lock,  &LK_RELEASE, 0,  &curproc); }  &while (0););
	}' unless defined(&vm_map_unlock);
	eval 'sub vm_map_lock_read {
	    local($map) = @_;
    	    eval q( &do {  &printf (\\"locking map LK_SHARED: 0x%x\\\\n\\", $map);  &lockmgr(&-> &lock,  &LK_SHARED, 0,  &curproc); }  &while (0););
	}' unless defined(&vm_map_lock_read);
	eval 'sub vm_map_unlock_read {
	    local($map) = @_;
    	    eval q( &do {  &printf (\\"locking map LK_RELEASE: 0x%x\\\\n\\", $map);  &lockmgr(&-> &lock,  &LK_RELEASE, 0,  &curproc); }  &while (0););
	}' unless defined(&vm_map_unlock_read);
    } else {
	eval 'sub vm_map_unlock {
	    local($map) = @_;
    	    eval q( &lockmgr(&-> &lock,  &LK_RELEASE, 0,  &curproc););
	}' unless defined(&vm_map_unlock);
	eval 'sub vm_map_lock_read {
	    local($map) = @_;
    	    eval q( &lockmgr(&-> &lock,  &LK_SHARED, 0,  &curproc););
	}' unless defined(&vm_map_lock_read);
	eval 'sub vm_map_unlock_read {
	    local($map) = @_;
    	    eval q( &lockmgr(&-> &lock,  &LK_RELEASE, 0,  &curproc););
	}' unless defined(&vm_map_unlock_read);
    }
    if(defined( &MAP_LOCK_DIAGNOSTIC)) {
    }
    eval 'sub vm_map_lock_upgrade {
        local($map) = @_;
	    eval q( &_vm_map_lock_upgrade($map,  &curproc));
    }' unless defined(&vm_map_lock_upgrade);
    if(defined( &MAP_LOCK_DIAGNOSTIC)) {
	eval 'sub vm_map_lock_downgrade {
	    local($map) = @_;
    	    eval q( &do {  &printf (\\"locking map LK_DOWNGRADE: 0x%x\\\\n\\", $map);  &lockmgr(&-> &lock,  &LK_DOWNGRADE, 0,  &curproc); }  &while (0););
	}' unless defined(&vm_map_lock_downgrade);
    } else {
	eval 'sub vm_map_lock_downgrade {
	    local($map) = @_;
    	    eval q( &lockmgr(&-> &lock,  &LK_DOWNGRADE, 0,  &curproc););
	}' unless defined(&vm_map_lock_downgrade);
    }
    eval 'sub vm_map_set_recursive {
        local($map) = @_;
	    eval q({  &simple_lock(($map)-> ($lock->{lk_interlock})); ($map)-> ($lock->{lk_flags}) |=  &LK_CANRECURSE;  &simple_unlock(($map)-> ($lock->{lk_interlock})); });
    }' unless defined(&vm_map_set_recursive);
    eval 'sub vm_map_clear_recursive {
        local($map) = @_;
	    eval q({  &simple_lock(($map)-> ($lock->{lk_interlock})); ($map)-> ($lock->{lk_flags}) &= ~ &LK_CANRECURSE;  &simple_unlock(($map)-> ($lock->{lk_interlock})); });
    }' unless defined(&vm_map_clear_recursive);
    eval 'sub vm_map_min {
        local($map) = @_;
	    eval q((($map)-> &min_offset));
    }' unless defined(&vm_map_min);
    eval 'sub vm_map_max {
        local($map) = @_;
	    eval q((($map)-> &max_offset));
    }' unless defined(&vm_map_max);
    eval 'sub vm_map_pmap {
        local($map) = @_;
	    eval q((($map)-> &pmap));
    }' unless defined(&vm_map_pmap);
    eval 'sub MAX_KMAP () {10;}' unless defined(&MAX_KMAP);
    eval 'sub MAX_KMAPENT () {128;}' unless defined(&MAX_KMAPENT);
    eval 'sub MAX_MAPENT () {128;}' unless defined(&MAX_MAPENT);
    eval 'sub MAP_COPY_NEEDED () {0x1;}' unless defined(&MAP_COPY_NEEDED);
    eval 'sub MAP_COPY_ON_WRITE () {0x2;}' unless defined(&MAP_COPY_ON_WRITE);
    eval 'sub MAP_NOFAULT () {0x4;}' unless defined(&MAP_NOFAULT);
    eval 'sub VM_FAULT_NORMAL () {0;}' unless defined(&VM_FAULT_NORMAL);
    eval 'sub VM_FAULT_CHANGE_WIRING () {1;}' unless defined(&VM_FAULT_CHANGE_WIRING);
    eval 'sub VM_FAULT_USER_WIRE () {2;}' unless defined(&VM_FAULT_USER_WIRE);
    eval 'sub VM_FAULT_WIRE_MASK () {( &VM_FAULT_CHANGE_WIRING| &VM_FAULT_USER_WIRE);}' unless defined(&VM_FAULT_WIRE_MASK);
    eval 'sub VM_FAULT_HOLD () {4;}' unless defined(&VM_FAULT_HOLD);
    eval 'sub VM_FAULT_DIRTY () {8;}' unless defined(&VM_FAULT_DIRTY);
    if(defined(&KERNEL)) {
    }
}
1;
